package com.company.surveypoc.entity;

import io.jmix.core.DeletePolicy;
import io.jmix.core.annotation.DeletedBy;
import io.jmix.core.annotation.DeletedDate;
import io.jmix.core.entity.annotation.JmixGeneratedValue;
import io.jmix.core.entity.annotation.OnDelete;
import io.jmix.core.entity.annotation.OnDeleteInverse;
import io.jmix.core.metamodel.annotation.Composition;
import io.jmix.core.metamodel.annotation.InstanceName;
import io.jmix.core.metamodel.annotation.JmixEntity;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.Date;
import java.util.List;
import java.util.UUID;

@JmixEntity
@Table(name = "SURVEY_QUESTION", indexes = {
        @Index(name = "IDX_SURVEY_QUESTION_SURVEY", columnList = "SURVEY_ID")
})
@Entity
public class SurveyQuestion {
    @InstanceName
    @Column(name = "QUESTION_TEXT", nullable = false)
    @Lob
    @NotNull
    private String questionText;

    @Column(name = "ANSWER_TYPE", nullable = false)
    @NotNull
    private String answerType;

    @Column(name = "INIT_REQUIRED", nullable = false)
    @NotNull
    private Boolean initRequired = true;

    @Column(name = "INIT_VISIBLE", nullable = false)
    @NotNull
    private Boolean initVisible = true;

    @Column(name = "DISPLAY_ORDER", nullable = false)
    @NotNull
    private Integer displayOrder;

    @OrderBy("displayOrder")
    @OnDelete(DeletePolicy.CASCADE)
    @Composition
    @OneToMany(mappedBy = "surveyQuestion")
    private List<SurveyAnswerOption> answerOptions;

    @JmixGeneratedValue
    @Column(name = "ID", nullable = false)
    @Id
    private Integer id;

    @JmixGeneratedValue
    @Column(name = "UUID")
    private UUID uuid;

    @Column(name = "VERSION", nullable = false)
    @Version
    private Integer version;

    @CreatedBy
    @Column(name = "CREATED_BY")
    private String createdBy;

    @CreatedDate
    @Column(name = "CREATED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date createdDate;

    @LastModifiedBy
    @Column(name = "LAST_MODIFIED_BY")
    private String lastModifiedBy;

    @LastModifiedDate
    @Column(name = "LAST_MODIFIED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date lastModifiedDate;

    @DeletedBy
    @Column(name = "DELETED_BY")
    private String deletedBy;

    @DeletedDate
    @Column(name = "DELETED_DATE")
    @Temporal(TemporalType.TIMESTAMP)
    private Date deletedDate;

    @OnDeleteInverse(DeletePolicy.CASCADE)
    @JoinColumn(name = "SURVEY_ID", nullable = false)
    @ManyToOne(fetch = FetchType.LAZY, optional = false)
    private Survey survey;

    public Boolean getInitVisible() {
        return initVisible;
    }

    public void setInitVisible(Boolean initVisible) {
        this.initVisible = initVisible;
    }

    public Boolean getInitRequired() {
        return initRequired;
    }

    public void setInitRequired(Boolean initRequired) {
        this.initRequired = initRequired;
    }

    public Survey getSurvey() {
        return survey;
    }

    public void setSurvey(Survey survey) {
        this.survey = survey;
    }

    public List<SurveyAnswerOption> getAnswerOptions() {
        return answerOptions;
    }

    public void setAnswerOptions(List<SurveyAnswerOption> answerOptions) {
        this.answerOptions = answerOptions;
    }

    public Integer getDisplayOrder() {
        return displayOrder;
    }

    public void setDisplayOrder(Integer displayOrder) {
        this.displayOrder = displayOrder;
    }

    public SurveyAnswerTypeEnum getAnswerType() {
        return answerType == null ? null : SurveyAnswerTypeEnum.fromId(answerType);
    }

    public void setAnswerType(SurveyAnswerTypeEnum answerType) {
        this.answerType = answerType == null ? null : answerType.getId();
    }

    public String getQuestionText() {
        return questionText;
    }

    public void setQuestionText(String questionText) {
        this.questionText = questionText;
    }

    public Date getDeletedDate() {
        return deletedDate;
    }

    public void setDeletedDate(Date deletedDate) {
        this.deletedDate = deletedDate;
    }

    public String getDeletedBy() {
        return deletedBy;
    }

    public void setDeletedBy(String deletedBy) {
        this.deletedBy = deletedBy;
    }

    public Date getLastModifiedDate() {
        return lastModifiedDate;
    }

    public void setLastModifiedDate(Date lastModifiedDate) {
        this.lastModifiedDate = lastModifiedDate;
    }

    public String getLastModifiedBy() {
        return lastModifiedBy;
    }

    public void setLastModifiedBy(String lastModifiedBy) {
        this.lastModifiedBy = lastModifiedBy;
    }

    public Date getCreatedDate() {
        return createdDate;
    }

    public void setCreatedDate(Date createdDate) {
        this.createdDate = createdDate;
    }

    public String getCreatedBy() {
        return createdBy;
    }

    public void setCreatedBy(String createdBy) {
        this.createdBy = createdBy;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public UUID getUuid() {
        return uuid;
    }

    public void setUuid(UUID uuid) {
        this.uuid = uuid;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }
}