package com.company.surveypoc.screen.survey;

import io.jmix.ui.ScreenBuilders;
import io.jmix.ui.action.Action;
import io.jmix.ui.component.GroupTable;
import io.jmix.ui.screen.*;
import com.company.surveypoc.entity.Survey;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Objects;

@UiController("Survey.browse")
@UiDescriptor("survey-browse.xml")
@LookupComponent("surveysTable")
public class SurveyBrowse extends StandardLookup<Survey> {
    @Autowired
    private ScreenBuilders screenBuilders;
    @Autowired
    private GroupTable<Survey> surveysTable;

    @Subscribe("surveysTable.rules")
    public void onSurveysTableRules(final Action.ActionPerformedEvent event) {
        Survey survey = Objects.requireNonNull(surveysTable.getSingleSelected());
        screenBuilders.editor(Survey.class, this)
                .withScreenClass(SurveyRulesEdit.class)
                .editEntity(survey)
                .build()
                .show();
    }
}