package com.company.surveypoc.screen.surveyrulecondition;

import com.company.surveypoc.entity.SurveyQuestion;
import io.jmix.core.DataManager;
import io.jmix.ui.model.CollectionLoader;
import io.jmix.ui.screen.*;
import com.company.surveypoc.entity.SurveyRuleCondition;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

@UiController("SurveyRuleCondition.edit")
@UiDescriptor("survey-rule-condition-edit.xml")
@EditedEntityContainer("surveyRuleConditionDc")
public class SurveyRuleConditionEdit extends StandardEditor<SurveyRuleCondition> {
    private static final Logger log = LoggerFactory.getLogger(SurveyRuleConditionEdit.class);
    @Autowired
    private DataManager dataManager;
    @Autowired
    private CollectionLoader<SurveyQuestion> surveyQuestionsDl;

    @Subscribe(id = "surveyQuestionsDl", target = Target.DATA_LOADER)
    public void onSurveyQuestionsDlPreLoad(final CollectionLoader.PreLoadEvent<SurveyQuestion> event) {
        log.info("Survey: " + getEditedEntity().getSurveyRule().getSurvey());
        surveyQuestionsDl.setParameter("survey", getEditedEntity().getSurveyRule().getSurvey());
    }

//    @Install(to = "surveyQuestionsDl", target = Target.DATA_LOADER)
//    private List<SurveyQuestion> surveyQuestionsDlLoadDelegate(final LoadContext<SurveyQuestion> loadContext) {
//        return dataManager.load(SurveyQuestion.class)
//                .query("select e from SurveyQuestion e where e.survey = :survey order by e.displayOrder")
//                .parameter("survey", getEditedEntity().getSurveyRule().getSurvey())
//                .list();
//    }
//
//    @Install(to = "surveyAnswerOptionsDl", target = Target.DATA_LOADER)
//    private List<SurveyAnswerOption> surveyAnswerOptionsDlLoadDelegate(final LoadContext<SurveyAnswerOption> loadContext) {
//        return dataManager.load(SurveyAnswerOption.class)
//                .query("select e from SurveyAnswerOption e where e.surveyQuestion = :surveyQuestion order by e.displayOrder")
//                .parameter("surveyQuestion", getEditedEntity().getSurveyQuestion())
//                .list();
//    }
}