package com.company.surveypoc.service;

import com.company.surveypoc.entity.SurveyAnswerOption;
import com.company.surveypoc.entity.SurveyQuestion;
import io.jmix.core.DataManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Service
@Transactional
public class SurveyResponseService {
    @Autowired
    private DataManager dataManager;
    private static final String GET_ANSWER_OPTIONS =
            "select e from SurveyAnswerOption e where e.surveyQuestion = :surveyQuestion order by e.displayOrder";

    public List<SurveyAnswerOption> getAnswerOptions(SurveyQuestion surveyQuestion) {
        return dataManager.load(SurveyAnswerOption.class)
                .query(GET_ANSWER_OPTIONS)
                .parameter("surveyQuestion", surveyQuestion)
                .fetchPlan("_local")
                .list();
    }
}